<?php

# logger class will be used for logging event notifications
 require "logger.php";
 require "aps/2/runtime.php";

/**
 * Class event
 * @type("http://aps-standard.org/samples/event-mgmt/event/1.0")
 * @implements("http://aps-standard.org/types/core/resource/1.0")
 */
class event extends \APS\ResourceBase {


 	## Define a Logger function that will log a new Event Notification as a message
 	function logger($message){
 		$requester=$_SERVER['REMOTE_ADDR'];
 		$log = new Logging();
 		$log->logfile('./'.$this->aps->id.'.log');
 		$log->logwrite($requester.": ".$message);
 		$log->logclose();
 	}
 	 	 
 	## In accordance with the APS type,
    ## define the method that returns the list of Notifications logged by the service
    ## Define a function that returns the list of Notifications logged by the service
    /**
     * @verb(GET)
     * @path("/readNotifications")
     * @return(string)
     */
 	public function readNotifications() {
 		$log = new Logging();
 		$log->logfile('./'.$this->aps->id.'.log');
 		return $log->flushlog();
 	} 	  
 	

     ## In accordance with the APS type,
     ## for each type of Event Notifications, define a handler
    /**
     * @verb(POST)
     * @path("/onVPSavailable")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onVPSavailable($notification) {
     	$this->logger("VPS created: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onVPSremove")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onVPSremove($notification) {
     	$this->logger("VPS removed: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onVPSofferLink")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onVPSofferLink($notification) {
     	$this->logger("New offer Linked: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onVPSofferUnlink")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onVPSofferUnlink($notification) {
     	$this->logger("Offer Unlinked: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onVPSuserLink")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onVPSuserLink($notification) {
     	$this->logger("New user Linked: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onVPSuserUnlink")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onVPSuserUnlink($notification) {
     	$this->logger("User UnLinked: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onVPSchange")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onVPSchange($notification) {
     	$this->logger("VPS properties changed: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onDomainAvailable")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onDomainAvailable($notification) {
     	$this->logger("New Domain available: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onDomainRemove")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onDomainRemove($notification) {
     	$this->logger("Domain removed: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onUserAvailable")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onUserAvailable($notification) {
     	$this->logger("New User available: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onUserRemove")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onUserRemove($notification) {
     	$this->logger("User removed: ".json_format($notification));
     }

    /**
     * @verb(POST)
     * @path("/onSubscriptionRenew")
     * @param("http://aps-standard.org/types/core/resource/1.0#Notification",body)
     */
     public function onSubscriptionRenew($notification) {
         $this->logger("Subscription renewed: ".json_format($notification));
     }

 }
?>