<?php

	define('APS_DEVELOPMENT_MODE', true);
	require "aps/2/runtime.php";	

	class CPU {
		/**
		 * @type("integer")
		 * @title("Number of CPUs")
		 * @description("Number of CPU cores")
		 */
		public $number;
	}
	
	class OS {
		/**
		 * @type("string")
		 * @title("OS Name")
		 * @description("Operating System Name")
		 */
		public $name;
	
		/**
		 * @type("string")
		 * @title("OS Version")
		 * @description("Operating System version")
		 */
		public $version;
	}
	
	class Hardware {
		/**
		 * @type("integer")
		 * @title("RAM Size")
		 * @description("RAM size in GB")
		 */
		public $memory;
	
		/**
		 * @type("integer")
		 * @title("Disk Space")
		 * @description("Disk space in GB")
		 */
		public $diskspace;
	
		/**
		 * @type("CPU")
		 * @title("CPU")
		 * @description("Server CPU parameters")
		 */
		public $CPU;
	}
	
	class Platform {
		/**
		 * @type("string")
		 * @title("Architecture")
		 * @description("Platform architecture")
		 */
		public $arch;
	
		/**
		 * @type("OS")
		 * @title("OS Parameters")
		 * @description("Parameters of operating system")
		 */
		public $OS;
	}
	
	/**
	* Class offer
	* @type("http://aps-standard.org/samples/event-mgmt/offer/1.0")
	* @implements("http://aps-standard.org/types/core/resource/1.0","http://aps-standard.org/types/core/profile/service/1.0")
	*/
	class offer extends \APS\ResourceBase {
		
		/**
		 * @link("http://aps-standard.org/samples/event-mgmt/cloud/1.0")
		 * @required
		 */
		public $cloud;
		
		/**
		 * @link("http://aps-standard.org/samples/event-mgmt/vps/1.0[]")
		 */
		public $vpses;

		/**
		 * @type(string)
		 * @title("Offer Name")
		 */
		public $name;
		
		/**
		 * @type(string)
		 * @title("Offer Description")
		 */
		public $description;
		
		/**
		 * @type("Hardware")
		 * @title("Hardware")
		 * @description("Server Hardware")
		 */
		public $hardware;
		
		/**
		 * @type("Platform")
		 * @title("Plaform")
		 * @description("OS Platform")
		 */
		public $platform;
		
	}
	
?>
