define([
  "dojo/_base/declare",
  "dojo/when",
  "aps/xhr",
  "aps/View",
  "aps/Output",
  "./displayError"
], function(declare, when, xhr, View, Output, displayError) {
	var self;
	var logContent = "";
	return declare(View, {
		init: function() {
			self = this;
			var refresh = function() {
				when(
					xhr(
						"/aps/2/resources/" + aps.context.vars.events.aps.id +
                            "/readNotifications",
						{ method: "GET", handleAs: "text" }
					),
					function(logContent) {
		                if (logContent.length > 0)
							self.byId("events_general").addChild(new Output({
								label: "", innerHTML: "<pre>"+logContent+"</pre>"
							}));
		                aps.apsc.cancelProcessing();
		                self.byId("events_refresh").cancel();
		            },
		            function(err) {
		                displayError(err);
		                aps.apsc.cancelProcessing();
		                this.cancel();
		                self.byId("events_refresh").cancel();
	            });
			};
 
			return ["aps/Container", { id: this.genId("page") }, [
				["aps/Toolbar", [
					["aps/ToolbarButton", {
						id: this.genId("events_refresh"),
						iconClass: "sb-refresh",
						label: "Refresh",
						onClick: refresh
					}]
				]],
				["aps/FieldSet", {
						id: this.genId("events_general"),
						title: "Event Notifications"
					}, [
					["aps/Output", {
						id: this.genId("events_notifications"),
						label: "Event Notifications",
						value: logContent
					}]
				]]
			]];
		}	// End of Init
	});		// End of Declare
});			// End of Define
